import Module from "./module.js";
import Node, { MetadataMap, KeyValueMap } from "./node.js";
import Group from "./group.js";
export declare type NodeMap = {
    [nodeId: number]: Node | Module;
};
export declare type GroupMap = {
    [groupId: number]: Group;
};
declare class Patch {
    id: number;
    nodes: NodeMap;
    ownerModuleNode: Node | Module | null;
    groups: GroupMap;
    constructor(ownerNode: Node | Module | null);
    isModule(): boolean;
    createGroup(id: number, name: string, comment?: string, nodeIdList?: number[]): Group;
    removeGroup(id: number): Group;
    createNode(id: number, componentIdentKey: string, properties?: KeyValueMap, metadata?: MetadataMap): Node | Module | null;
    removeNode(nodeId: number, removePorts?: boolean): {
        removedFromGroupId: number | null;
        removedEmptyGroup: Group | null;
    };
    getNode(nodeId: number): Node | Module;
    findConnection(connectionId: number): import("./connection.js").default | null;
    mapNode(node: Node): void;
}
export default Patch;
